diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev2/tasks/child_create.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/tasks/child_create.c
--- strongswan-5.8.4/src/libcharon/sa/ikev2/tasks/child_create.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/tasks/child_create.c	2023-05-13 16:28:02.480139000 +0300
@@ -1853,7 +1853,10 @@
 	{
 		this->proposals->destroy_offset(this->proposals, offsetof(proposal_t, destroy));
 	}
-
+	if (!this->rekey && !this->retry)
+	{
+		this->dh_group = MODP_NONE;
+	}
 	this->ike_sa = ike_sa;
 	this->keymat = (keymat_v2_t*)ike_sa->get_keymat(ike_sa);
 	this->proposal = NULL;
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev2/tasks/ike_auth.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/tasks/ike_auth.c
--- strongswan-5.8.4/src/libcharon/sa/ikev2/tasks/ike_auth.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/tasks/ike_auth.c	2023-05-13 16:28:32.140877000 +0300
@@ -1009,9 +1009,19 @@
 			if (!this->ike_sa->supports_extension(this->ike_sa,
 												  EXT_EAP_ONLY_AUTHENTICATION))
 			{
-				DBG1(DBG_IKE, "configured EAP-only authentication, but peer "
-					 "does not support it");
-				goto peer_auth_failed;
+				if (lib->settings->get_bool(lib->settings,
+							"%s.force_eap_only_authentication", FALSE, lib->ns))
+				{
+					DBG1(DBG_IKE, "ignore missing %N notify and use EAP-only "
+						 "authentication", notify_type_names,
+						 EAP_ONLY_AUTHENTICATION);
+				}
+				else
+				{
+					DBG1(DBG_IKE, "configured EAP-only authentication, but "
+						 "peer does not support it");
+					goto peer_auth_failed;
+				}
 			}
 		}
 		else
diff -ruN strongswan-5.8.4/src/libcharon/sa/ikev2/tasks/ike_cert_post.c strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/tasks/ike_cert_post.c
--- strongswan-5.8.4/src/libcharon/sa/ikev2/tasks/ike_cert_post.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/ikev2/tasks/ike_cert_post.c	2023-03-24 10:58:46.666283000 +0300
@@ -130,11 +130,13 @@
 	cert = auth->get(auth, AUTH_RULE_SUBJECT_CERT);
 	if (!cert)
 	{
+		DBG1(DBG_IKE, "tryed to send end entity cert but failed on get");
 		return FALSE;
 	}
 	payload = build_cert_payload(this, cert);
 	if (!payload)
 	{
+		DBG1(DBG_IKE, "tryed to send end entity cert but failed on build");
 		return FALSE;
 	}
 	DBG1(DBG_IKE, "sending end entity cert \"%Y\"", cert->get_subject(cert));
diff -ruN strongswan-5.8.4/src/libcharon/sa/keymat.c strongswancont-5.8.4-svc/src/libcharon/sa/keymat.c
--- strongswan-5.8.4/src/libcharon/sa/keymat.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/keymat.c	2022-07-06 15:47:34.610981000 +0300
@@ -65,6 +65,11 @@
 	keylen_entry_t map[] = {
 		{ENCR_DES,					 64},
 		{ENCR_3DES,					192},
+		{ENCR_GOST28147_CTR,		256},
+		{ENCR_GOST28147_CFB,		256},
+		{ENCR_BELT_CBC,				256},
+		{ENCR_BELT_CFB,				256},
+		{ENCR_BELT_CTR,				256},
 		{ENCR_CHACHA20_POLY1305,	256},
 	};
 	int i;
@@ -95,6 +100,14 @@
 		{AUTH_HMAC_SHA2_512_256,	512},
 		{AUTH_AES_XCBC_96,			128},
 		{AUTH_AES_CMAC_96,			128},
+		{AUTH_BELT_HASH_LEGACY,		256},
+		{AUTH_GOST_MAC_LEGACY,		256},
+		{AUTH_BELT_MAC_LEGACY,		256},
+		{AUTH_BELT_HMAC_LEGACY,		256},
+		{AUTH_BELT_HASH,			256},
+		{AUTH_GOST_MAC,				256},
+		{AUTH_BELT_MAC,				256},
+		{AUTH_BELT_HMAC,			256},
 	};
 	int i;
 
diff -ruN strongswan-5.8.4/src/libcharon/sa/task_manager.c strongswancont-5.8.4-svc/src/libcharon/sa/task_manager.c
--- strongswan-5.8.4/src/libcharon/sa/task_manager.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libcharon/sa/task_manager.c	2022-07-06 15:47:34.610981000 +0300
@@ -25,7 +25,7 @@
 u_int task_manager_total_retransmit_timeout()
 {
 	double timeout, base, limit = 0, total = 0;
-	int tries, i;
+	int tries, max_tries = 0, i;
 
 	tries = lib->settings->get_int(lib->settings, "%s.retransmit_tries",
 								   RETRANSMIT_TRIES, lib->ns);
@@ -36,9 +36,18 @@
 	limit = lib->settings->get_double(lib->settings, "%s.retransmit_limit",
 									  0, lib->ns);
 
+	if (base > 1)
+	{
+		max_tries = log(UINT32_MAX/(1000.0 * timeout))/log(base);
+	}
+
 	for (i = 0; i <= tries; i++)
 	{
-		double interval = timeout * pow(base, i);
+		double interval = UINT32_MAX/1000.0;
+		if (max_tries && i <= max_tries)
+		{
+			interval = timeout * pow(base, i);
+		}
 		if (limit)
 		{
 			interval = min(interval, limit);
diff -ruN strongswan-5.8.4/src/libipsec/codel_queue.c strongswancont-5.8.4-svc/src/libipsec/codel_queue.c
--- strongswan-5.8.4/src/libipsec/codel_queue.c	1970-01-01 03:00:00.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libipsec/codel_queue.c	2020-11-30 16:52:55.000000000 +0300
@@ -0,0 +1,354 @@
+/*
+ * Copyright (C) 2013 Martin Willi
+ * Copyright (C) 2013 revosec AG
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * for more details.
+ */
+
+#include "codel_queue.h"
+
+#include <threading/thread.h>
+#include <threading/mutex.h>
+#include <threading/condvar.h>
+#include <collections/linked_list.h>
+
+#include <math.h>
+
+typedef struct private_codel_queue_t private_codel_queue_t;
+
+/**
+ * Timestamp with "good" resolution
+ */
+typedef uint64_t timestamp_t;
+
+/**
+ * Entry for an packet
+ */
+typedef struct {
+	void *packet;
+	timestamp_t stamp;
+	u_int len;
+} entry_t;
+
+/**
+ * Private data of an codel_queue_t object.
+ */
+struct private_codel_queue_t {
+
+	/**
+	 * Public codel_queue_t interface.
+	 */
+	codel_queue_t public;
+
+	/**
+	 * Linked list containing all items in the queue
+	 */
+	linked_list_t *list;
+
+	/**
+	 * Offset of object destructor for queued entry packets
+	 */
+	int destroy_offset;
+
+	/**
+	 * Mutex used to synchronize access to the queue
+	 */
+	mutex_t *mutex;
+
+	/**
+	 * Condvar used to wait for items
+	 */
+	condvar_t *condvar;
+
+	/**
+	 * Time when we'll declare we're above target (0 if below)
+	 */
+	timestamp_t first_above;
+
+	/**
+	 * Time to drop next packet
+	 */
+	timestamp_t drop_next;
+
+	/**
+	 * Packets dropped since going into drop state
+	 */
+	u_int count;
+
+	/**
+	 * Size of queue, in bytes
+	 */
+	u_int len;
+
+	/**
+	 * TRUE if in drop state
+	 */
+	bool dropping;
+
+	/**
+	 * Target queue delay
+	 */
+	timestamp_t target;
+
+	/**
+	 * Sliding minimum time window width
+	 */
+	timestamp_t interval;
+
+	/**
+	 * Maximum packet size in bytes (should use interface MTU)
+	 */
+	u_int maxpacket;
+};
+
+/**
+ * Create a timestamp for now
+ */
+static timestamp_t timestamp_now()
+{
+	timeval_t tv;
+
+	time_monotonic(&tv);
+
+	return tv.tv_sec * 1000 * 1000 + tv.tv_usec;
+}
+
+/**
+ * Convert miliseconds to timestamp_now() resolution
+ */
+static timestamp_t timestamp_from_ms(u_int ms)
+{
+	return ms * 1000;
+}
+
+/**
+ * Calculate frequency for dropping
+ */
+static timestamp_t control_law(private_codel_queue_t *this, timestamp_t t)
+{
+	return t + this->interval / (timestamp_t)sqrt(this->count);
+}
+
+/**
+ * Destroy a packet with the destructor offset
+ */
+static void destroy_packet(private_codel_queue_t *this, void *packet)
+{
+	void (**method)(void*);
+
+	method = packet + this->destroy_offset;
+	(*method)(packet);
+}
+
+METHOD(codel_queue_t, enqueue, void,
+	private_codel_queue_t *this, void *packet, u_int len)
+{
+	entry_t *entry;
+
+	INIT(entry,
+		.packet = packet,
+		.len = len,
+		.stamp = timestamp_now(),
+	);
+
+	this->mutex->lock(this->mutex);
+
+	this->list->insert_first(this->list, entry);
+	this->len += len;
+
+	this->mutex->unlock(this->mutex);
+
+	this->condvar->signal(this->condvar);
+}
+
+/**
+ * Dequeue an entry
+ */
+static entry_t* dequeue_entry(private_codel_queue_t *this)
+{
+	entry_t *entry;
+	bool oldstate;
+
+	thread_cleanup_push((thread_cleanup_t)this->mutex->unlock, this->mutex);
+
+	/* ensure that a canceled thread does not dequeue any items */
+	thread_cancellation_point();
+
+	while (this->list->remove_last(this->list, (void**)&entry) != SUCCESS)
+	{
+		/* queue empty, get out of dropping state */
+		this->first_above = 0;
+		this->dropping = FALSE;
+
+		oldstate = thread_cancelability(TRUE);
+		this->condvar->wait(this->condvar, this->mutex);
+		thread_cancelability(oldstate);
+	}
+
+	thread_cleanup_pop(FALSE);
+
+	return entry;
+}
+
+/**
+ * CoDelized dequeue of a packet
+ */
+static void* dequeue_packet(private_codel_queue_t *this, timestamp_t now,
+							bool *ok_to_drop)
+{
+	entry_t *entry;
+	timestamp_t sojourn;
+	void *packet;
+
+	*ok_to_drop = FALSE;
+
+	entry = dequeue_entry(this);
+
+	this->len -= entry->len;
+	sojourn = now - entry->stamp;
+	if (sojourn < this->target || this->len < this->maxpacket)
+	{
+		/* below target delay */
+		this->first_above = 0;
+	}
+	else
+	{
+		if (this->first_above == 0)
+		{
+			/* first time above target delay */
+			this->first_above = now + this->interval;
+		}
+		else if (now >= this->first_above)
+		{
+			/* have been obove target delay for interval */
+			*ok_to_drop = TRUE;
+		}
+	}
+
+	packet = entry->packet;
+	free(entry);
+
+	return packet;
+}
+
+METHOD(codel_queue_t, dequeue, void*,
+	private_codel_queue_t *this)
+{
+	timestamp_t now;
+	bool ok_to_drop;
+	void *packet;
+
+	now = timestamp_now();
+
+	this->mutex->lock(this->mutex);
+
+	packet = dequeue_packet(this, now, &ok_to_drop);
+	if (this->dropping)
+	{
+		if (!ok_to_drop)
+		{
+			/* stop dropping after queue delay got acceptable */
+			this->dropping = FALSE;
+		}
+		else if (now >= this->drop_next)
+		{
+			/* continue dropping dropping packets more and more aggressively,
+			 * until queue delay gets acceptable */
+			while (now >= this->drop_next && this->dropping)
+			{
+				this->count++;
+				destroy_packet(this, packet);
+				packet = dequeue_packet(this, now, &ok_to_drop);
+				if (!ok_to_drop)
+				{
+					this->dropping = FALSE;
+				}
+				else
+				{
+					this->drop_next = control_law(this, this->drop_next);
+				}
+			}
+		}
+	}
+	else if (ok_to_drop)
+	{
+		if (now < this->drop_next + this->interval ||
+			now >= this->first_above + this->interval)
+		{
+			/* start dropping packets */
+			destroy_packet(this, packet);
+			packet = dequeue_packet(this, now, &ok_to_drop);
+			this->dropping = TRUE;
+
+			if (now < this->drop_next + this->interval)
+			{
+				if (this->count > 2)
+				{
+					this->count -= 2;
+				}
+				else
+				{
+					 this->count = 1;
+				}
+			}
+			else
+			{
+				this->count = 1;
+				this->drop_next = control_law(this, now);
+			}
+		}
+	}
+
+	this->mutex->unlock(this->mutex);
+
+	return packet;
+}
+
+METHOD(codel_queue_t, destroy, void,
+	private_codel_queue_t *this)
+{
+	entry_t *entry;
+
+	while (this->list->remove_last(this->list, (void**)&entry) == SUCCESS)
+	{
+		destroy_packet(this, entry->packet);
+		free(entry);
+	}
+	this->list->destroy(this->list);
+	this->condvar->destroy(this->condvar);
+	this->mutex->destroy(this->mutex);
+	free(this);
+}
+
+/**
+ * See header
+ */
+codel_queue_t *codel_queue_create(int destroy_offset, u_int mtu)
+{
+	private_codel_queue_t *this;
+
+	INIT(this,
+		.public = {
+			.enqueue = _enqueue,
+			.dequeue = _dequeue,
+			.destroy = _destroy,
+		},
+		.list = linked_list_create(),
+		.mutex = mutex_create(MUTEX_TYPE_DEFAULT),
+		.condvar = condvar_create(CONDVAR_TYPE_DEFAULT),
+		.destroy_offset = destroy_offset,
+		.maxpacket = mtu,
+		.target = timestamp_from_ms(5),
+		.interval = timestamp_from_ms(100),
+	);
+
+	return &this->public;
+}
diff -ruN strongswan-5.8.4/src/libipsec/codel_queue.h strongswancont-5.8.4-svc/src/libipsec/codel_queue.h
--- strongswan-5.8.4/src/libipsec/codel_queue.h	1970-01-01 03:00:00.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libipsec/codel_queue.h	2020-11-30 16:52:55.000000000 +0300
@@ -0,0 +1,68 @@
+/*
+ * Copyright (C) 2013 Martin Willi
+ * Copyright (C) 2013 revosec AG
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * for more details.
+ */
+
+/**
+ * @defgroup codel_queue codel_queue
+ * @{ @ingroup ipsec
+ */
+
+#ifndef CODEL_QUEUE_H_
+#define CODEL_QUEUE_H_
+
+typedef struct codel_queue_t codel_queue_t;
+
+#include <library.h>
+
+/**
+ * A CoDel implementation.
+ *
+ * Implements a packet queue with "Controlled Delay", as described on
+ *    http://queue.acm.org/detail.cfm?id=2209336
+ */
+struct codel_queue_t {
+
+	/**
+	 * Enqueue a packet to the CoDel queue.
+	 *
+	 * @param packet		packet to enqueue
+	 * @param len			len of packet to enqueue
+	 */
+	void (*enqueue)(codel_queue_t *this, void *packet, u_int len);
+
+	/**
+	 * Dequeue a queued packet from the CoDel queue.
+	 *
+	 * This call is blocking and does not return before a packet could be
+	 * dequeued.
+	 *
+	 * @return				dequeued packet
+	 */
+	void* (*dequeue)(codel_queue_t *this);
+
+	/**
+	 * Destroy a codel_queue_t, with all queued packets.
+	 */
+	void (*destroy)(codel_queue_t *this);
+};
+
+/**
+ * Create a codel_queue instance.
+ *
+ * @param destroy_offset		offset of destructor in queued packet objects
+ * @param mtu				maximum transfer unit of queue link
+ */
+codel_queue_t *codel_queue_create(int destroy_offset, u_int mtu);
+
+#endif /** CODEL_QUEUE_H_ @}*/
diff -ruN strongswan-5.8.4/src/libipsec/ipsec_processor.c strongswancont-5.8.4-svc/src/libipsec/ipsec_processor.c
--- strongswan-5.8.4/src/libipsec/ipsec_processor.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libipsec/ipsec_processor.c	2022-07-08 13:43:01.025711000 +0300
@@ -15,11 +15,11 @@
 
 #include "ipsec.h"
 #include "ipsec_processor.h"
+#include "codel_queue.h"
 
 #include <utils/debug.h>
 #include <library.h>
 #include <threading/rwlock.h>
-#include <collections/blocking_queue.h>
 #include <processing/jobs/callback_job.h>
 
 typedef struct private_ipsec_processor_t private_ipsec_processor_t;
@@ -37,12 +37,12 @@
 	/**
 	 * Queue for inbound packets (esp_packet_t*)
 	 */
-	blocking_queue_t *inbound_queue;
+	codel_queue_t *inbound_queue;
 
 	/**
 	 * Queue for outbound packets (ip_packet_t*)
 	 */
-	blocking_queue_t *outbound_queue;
+	codel_queue_t *outbound_queue;
 
 	/**
 	 * Registered inbound callback
@@ -59,6 +59,14 @@
 		ipsec_outbound_cb_t cb;
 		void *data;
 	} outbound;
+	
+	/**
+	 * Registered acquire callback
+	 */
+	struct {
+		ipsec_acquire_cb_t cb;
+		void *data;
+	} acquire;
 
 	/**
 	 * Lock used to synchronize access to the callbacks
@@ -209,7 +217,24 @@
 	sa = ipsec->sas->checkout_by_reqid(ipsec->sas, policy->get_reqid(policy),
 									   FALSE);
 	if (!sa)
-	{	/* TODO-IPSEC: send an acquire to upper layer */
+	{
+		this->lock->read_lock(this->lock);
+		if (this->acquire.cb)
+		{
+			uint32_t reqid = policy->get_reqid(policy);
+			traffic_selector_t *source_ts = policy->get_source_ts(policy),
+				*destination_ts = policy->get_destination_ts(policy);
+
+			source_ts = source_ts->clone(source_ts);
+			destination_ts = destination_ts->clone(destination_ts);
+
+			this->acquire.cb(this->acquire.data, reqid, source_ts, destination_ts);
+		}
+		else
+		{
+			DBG2(DBG_ESP, "No acquire callback registered.");
+		}
+		this->lock->unlock(this->lock);
 		DBG1(DBG_ESP, "could not find an outbound IPsec SA for reqid {%u}, "
 			 "dropping packet", policy->get_reqid(policy));
 		packet->destroy(packet);
@@ -238,13 +263,15 @@
 METHOD(ipsec_processor_t, queue_inbound, void,
 	private_ipsec_processor_t *this, esp_packet_t *packet)
 {
-	this->inbound_queue->enqueue(this->inbound_queue, packet);
+	this->inbound_queue->enqueue(this->inbound_queue, packet,
+								packet->packet.get_data(&packet->packet).len);
 }
 
 METHOD(ipsec_processor_t, queue_outbound, void,
 	private_ipsec_processor_t *this, ip_packet_t *packet)
 {
-	this->outbound_queue->enqueue(this->outbound_queue, packet);
+	this->outbound_queue->enqueue(this->outbound_queue, packet,
+								packet->get_encoding(packet).len);
 }
 
 METHOD(ipsec_processor_t, register_inbound, void,
@@ -287,13 +314,31 @@
 	this->lock->unlock(this->lock);
 }
 
+METHOD(ipsec_processor_t, register_acquire, void,
+	private_ipsec_processor_t *this, ipsec_acquire_cb_t cb, void *data)
+{
+	this->lock->write_lock(this->lock);
+	this->acquire.cb = cb;
+	this->acquire.data = data;
+	this->lock->unlock(this->lock);
+}
+
+METHOD(ipsec_processor_t, unregister_acquire, void,
+	private_ipsec_processor_t *this, ipsec_acquire_cb_t cb)
+{
+	this->lock->write_lock(this->lock);
+	if (this->acquire.cb == cb)
+	{
+		this->acquire.cb = NULL;
+	}
+	this->lock->unlock(this->lock);
+}
+
 METHOD(ipsec_processor_t, destroy, void,
 	private_ipsec_processor_t *this)
 {
-	this->inbound_queue->destroy_offset(this->inbound_queue,
-										offsetof(esp_packet_t, destroy));
-	this->outbound_queue->destroy_offset(this->outbound_queue,
-										 offsetof(ip_packet_t, destroy));
+	this->inbound_queue->destroy(this->inbound_queue);
+	this->outbound_queue->destroy(this->outbound_queue);
 	this->lock->destroy(this->lock);
 	free(this);
 }
@@ -313,10 +358,14 @@
 			.unregister_inbound = _unregister_inbound,
 			.register_outbound = _register_outbound,
 			.unregister_outbound = _unregister_outbound,
+			.register_acquire = _register_acquire,
+			.unregister_acquire = _unregister_acquire,			
 			.destroy = _destroy,
 		},
-		.inbound_queue = blocking_queue_create(),
-		.outbound_queue = blocking_queue_create(),
+		.inbound_queue = codel_queue_create(
+						offsetof(esp_packet_t, destroy), 1500),
+		.outbound_queue = codel_queue_create(
+						offsetof(ip_packet_t, destroy), 1500),
 		.lock = rwlock_create(RWLOCK_TYPE_DEFAULT),
 	);
 
diff -ruN strongswan-5.8.4/src/libipsec/ipsec_processor.h strongswancont-5.8.4-svc/src/libipsec/ipsec_processor.h
--- strongswan-5.8.4/src/libipsec/ipsec_processor.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libipsec/ipsec_processor.h	2022-07-08 13:44:24.979579000 +0300
@@ -46,6 +46,17 @@
 typedef void (*ipsec_outbound_cb_t)(void *data, esp_packet_t *packet);
 
 /**
+ * Callback called to raise acquire events.
+ * 
+ * @param data				data supplied during registration of the callback
+ * @param reqid				reqid of the matched IPsec policy
+ * @param source_ts			source traffic selector that the packet matched
+ * @param destination_ts	destinationtraffic selector that the packet matched
+ */
+typedef void (*ipsec_acquire_cb_t)(void *data, uint32_t reqid,
+	traffic_selector_t *source_ts, traffic_selector_t *destination_ts);
+
+/**
  *  IPsec processor
  */
 struct ipsec_processor_t {
@@ -98,6 +109,22 @@
 	void (*unregister_outbound)(ipsec_processor_t *this,
 								ipsec_outbound_cb_t cb);
 
+ 	/**
+	 * Register the callback used to raise an acquire event.
+	 * 
+	 * @param cb			the callback function
+	 * @param data			optional data provided to the callback
+	 */
+	void (*register_acquire)(ipsec_processor_t *this, ipsec_acquire_cb_t cb,
+							void *data);
+	
+	/**
+	 * Unregister a previously registered acquire callback.
+	 * 
+	 * @param cb			previously registered acquire callback
+	 */
+	void (*unregister_acquire)(ipsec_processor_t *this, ipsec_acquire_cb_t cb);
+
 	/**
 	 * Destroy an ipsec_processor_t.
 	 */
diff -ruN strongswan-5.8.4/src/libipsec/Makefile.am strongswancont-5.8.4-svc/src/libipsec/Makefile.am
--- strongswan-5.8.4/src/libipsec/Makefile.am	2018-05-28 14:30:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libipsec/Makefile.am	2022-07-08 13:45:59.357674000 +0300
@@ -5,6 +5,7 @@
 esp_context.c esp_context.h \
 esp_packet.c esp_packet.h \
 ip_packet.c ip_packet.h \
+codel_queue.c codel_queue.h \
 ipsec_event_listener.h \
 ipsec_event_relay.c ipsec_event_relay.h \
 ipsec_policy.c ipsec_policy.h \
@@ -18,6 +19,8 @@
 
 if USE_WINDOWS
   libipsec_la_LIBADD += -lws2_32
+else
+  libipsec_la_LIBADD += -lm
 endif
 
 AM_CPPFLAGS = \
diff -ruN strongswan-5.8.4/src/libstrongswan/Android.mk strongswancont-5.8.4-svc/src/libstrongswan/Android.mk
--- strongswan-5.8.4/src/libstrongswan/Android.mk	2019-11-21 14:55:54.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/Android.mk	2022-07-06 15:47:34.750983000 +0300
@@ -15,7 +15,7 @@
 crypto/rngs/rng.c crypto/rngs/rng_tester.c \
 crypto/prf_plus.c crypto/signers/signer.c \
 crypto/signers/mac_signer.c crypto/crypto_factory.c crypto/crypto_tester.c \
-crypto/diffie_hellman.c crypto/aead.c crypto/transform.c \
+crypto/diffie_hellman.c crypto/aead.c crypto/transform.c crypto/key_transformer.c \
 crypto/iv/iv_gen.c crypto/iv/iv_gen_rand.c crypto/iv/iv_gen_seq.c \
 crypto/iv/iv_gen_null.c \
 crypto/xofs/xof.c crypto/xofs/xof_bitspender.c \
diff -ruN strongswan-5.8.4/src/libstrongswan/collections/linked_list.h strongswancont-5.8.4-svc/src/libstrongswan/collections/linked_list.h
--- strongswan-5.8.4/src/libstrongswan/collections/linked_list.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/collections/linked_list.h	2022-07-08 12:14:09.208653000 +0300
@@ -26,6 +26,7 @@
 typedef struct linked_list_t linked_list_t;
 
 #include <collections/enumerator.h>
+#include "../utils/utils/status.h"
 
 /**
  * Function to match elements in a linked list
diff -ruN strongswan-5.8.4/src/libstrongswan/credentials/builder.c strongswancont-5.8.4-svc/src/libstrongswan/credentials/builder.c
--- strongswan-5.8.4/src/libstrongswan/credentials/builder.c	2019-08-27 16:26:53.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/credentials/builder.c	2022-11-08 10:06:44.347773000 +0300
@@ -27,6 +27,7 @@
 	"BUILD_BLOB_SSHKEY",
 	"BUILD_BLOB_ALGID_PARAMS",
 	"BUILD_KEY_SIZE",
+	"BUILD_KEY_INITIAL_RANDOM",
 	"BUILD_SIGNING_KEY",
 	"BUILD_SIGNING_CERT",
 	"BUILD_PUBLIC_KEY",
@@ -73,6 +74,15 @@
 	"BUILD_SAFE_PRIMES",
 	"BUILD_SHARES",
 	"BUILD_THRESHOLD",
+	"BUILD_USBBAR_PASS",
+	"BUILD_USBBAR_PWD",
+	"BUILD_BPKI_PARAMS",
+	"BUILD_BLOB_STB1176_KEY",
+	"BUILD_BIGN_PUBLIC_FROM_PRIVATE",
+	"BUILD_BPKI_PKCS10",
+	"BUILD_CERT_VALIDITY",
+	"BUILD_POLICY_GOVPKI",
+	"BUILD_78_EXTS_REQUEST_OID",
 	"BUILD_EDDSA_PUB",
 	"BUILD_EDDSA_PRIV_ASN1_DER",
 	"BUILD_CRITICAL_EXTENSION",
diff -ruN strongswan-5.8.4/src/libstrongswan/credentials/builder.h strongswancont-5.8.4-svc/src/libstrongswan/credentials/builder.h
--- strongswan-5.8.4/src/libstrongswan/credentials/builder.h	2019-08-27 16:26:53.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/credentials/builder.h	2022-11-08 10:07:30.044812000 +0300
@@ -64,6 +64,10 @@
 	BUILD_BLOB_ALGID_PARAMS,
 	/** key size in bits, as used for key generation, u_int */
 	BUILD_KEY_SIZE,
+
+	/** Initial random data, as used for key generation, chunk_t */
+	BUILD_KEY_INITIAL_RANDOM,
+
 	/** private key to use for signing, private_key_t* */
 	BUILD_SIGNING_KEY,
 	/** certificate used for signing, certificate_t* */
@@ -156,6 +160,23 @@
 	BUILD_SHARES,
 	/** minimum number of participating private key shares */
 	BUILD_THRESHOLD,
+	/** usb barrier wraped password file path */
+	BUILD_USBBAR_PASS,
+	/** usb barrier password */
+	BUILD_USBBAR_PWD,
+
+	BUILD_BPKI_PARAMS,
+	/** */
+	BUILD_BLOB_CONTACT_KEY,
+	/** BIGN public key from private */ 
+	BUILD_BIGN_PUBLIC_FROM_PRIVATE,
+	/** BPKI PKCS#10 certificate request, bool */
+	BUILD_BPKI_PKCS10,
+
+	BUILD_CERT_VALIDITY,
+	BUILD_POLICY_GOVPKI,
+	BUILD_78_EXTS_REQUEST_OID,
+	
 	/** EdDSA public key blob */
 	BUILD_EDDSA_PUB,
 	/** DER encoded ASN.1 EdDSA private key */
diff -ruN strongswan-5.8.4/src/libstrongswan/credentials/certificates/x509.h strongswancont-5.8.4-svc/src/libstrongswan/credentials/certificates/x509.h
--- strongswan-5.8.4/src/libstrongswan/credentials/certificates/x509.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/credentials/certificates/x509.h	2022-07-06 15:47:34.770983000 +0300
@@ -33,6 +33,7 @@
 typedef struct x509_cdp_t x509_cdp_t;
 typedef enum x509_flag_t x509_flag_t;
 typedef enum x509_constraint_t x509_constraint_t;
+typedef enum x509_key_usage_t x509_key_usage_t;
 
 /**
  * X.509 certificate flags.
@@ -84,6 +85,23 @@
 };
 
 /**
+ * X.509 key usage flags
+ */
+enum x509_key_usage_t
+{
+	X509_KU_NONE =              0,
+	X509_KU_DIGITAL_SIGNATURE =	(1<<0),
+	X509_KU_NON_REPUDIATION =	(1<<1),
+	X509_KU_KEY_ENCIPHERMENT =	(1<<2),
+	X509_KU_DATA_ENCIPHERMENT =	(1<<3),
+	X509_KU_KEY_AGREEMENT =		(1<<4),
+	X509_KU_KEY_CERT_SIGN =		(1<<5),
+	X509_KU_CRL_SIGN =			(1<<6),
+	X509_KU_ENCIPHER_ONLY =		(1<<7),
+	X509_KU_DECIPHER_ONLY =		(1<<8),
+};
+
+/**
  * X.509 certPolicy extension.
  */
 struct x509_cert_policy_t {
@@ -136,6 +154,13 @@
 	x509_flag_t (*get_flags)(x509_t *this);
 
 	/**
+	 * Get key usage flags for this certifcate.
+	 * 
+	 * @return			set of flags
+	 */
+	x509_key_usage_t (*get_keyUsage)(x509_t *this);
+
+	/**
 	 * Get the certificate serial number.
 	 *
 	 * @return			chunk pointing to internal serial number
diff -ruN strongswan-5.8.4/src/libstrongswan/credentials/cred_encoding.h strongswancont-5.8.4-svc/src/libstrongswan/credentials/cred_encoding.h
--- strongswan-5.8.4/src/libstrongswan/credentials/cred_encoding.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/credentials/cred_encoding.h	2022-07-06 15:47:34.778983000 +0300
@@ -71,6 +71,8 @@
 	KEYID_PGPV3,
 	/** PGPv4 fingerprint */
 	KEYID_PGPV4,
+	/** BELT fingerprint over subjectPublicKey */
+	KEYID_PUBKEY_BELT,
 
 	KEYID_MAX,
 
@@ -99,6 +101,11 @@
 	/** PGP Packet encoded certificate */
 	CERT_PGP_PKT,
 
+	/** BIGN subjectPublicKeyInfo encoding */
+	PUBKEY_SPKI_BIGN_ASN1_DER,
+	/** subjectPublicKey encoding */
+	PUBKEY_SPK_ASN1_DER,
+
 	CRED_ENCODING_MAX,
 };
 
@@ -144,6 +151,8 @@
 	CRED_PART_PKCS10_ASN1_DER,
 	/** a PGP encoded certificate */
 	CRED_PART_PGP_CERT,
+	/** a raw key value */
+	CRED_PART_RAW_KEY,
 	/** a DER encoded EdDSA public key */
 	CRED_PART_EDDSA_PUB_ASN1_DER,
 	/** a DER encoded EdDSA private key */
diff -ruN strongswan-5.8.4/src/libstrongswan/credentials/credential_manager.c strongswancont-5.8.4-svc/src/libstrongswan/credentials/credential_manager.c
--- strongswan-5.8.4/src/libstrongswan/credentials/credential_manager.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/credentials/credential_manager.c	2023-05-24 18:37:36.643162000 +0300
@@ -555,7 +555,7 @@
  */
 static bool check_lifetime(private_credential_manager_t *this,
 						   certificate_t *cert, char *label,
-						   int pathlen, bool trusted, auth_cfg_t *auth)
+						   int pathlen, bool anchor, auth_cfg_t *auth)
 {
 	time_t not_before, not_after;
 	cert_validator_t *validator;
@@ -570,7 +570,7 @@
 			continue;
 		}
 		status = validator->check_lifetime(validator, cert,
-										   pathlen, trusted, auth);
+										   pathlen, anchor, auth);
 		if (status != NEED_MORE)
 		{
 			break;
@@ -603,13 +603,13 @@
  */
 static bool check_certificate(private_credential_manager_t *this,
 				certificate_t *subject, certificate_t *issuer, bool online,
-				int pathlen, bool trusted, auth_cfg_t *auth)
+				int pathlen, bool anchor, auth_cfg_t *auth)
 {
 	cert_validator_t *validator;
 	enumerator_t *enumerator;
 
 	if (!check_lifetime(this, subject, "subject", pathlen, FALSE, auth) ||
-		!check_lifetime(this, issuer, "issuer", pathlen + 1, trusted, auth))
+		!check_lifetime(this, issuer, "issuer", pathlen + 1, anchor, auth))
 	{
 		return FALSE;
 	}
@@ -622,7 +622,7 @@
 			continue;
 		}
 		if (!validator->validate(validator, subject, issuer,
-								 online, pathlen, trusted, auth))
+								 online, pathlen, anchor, auth))
 		{
 			enumerator->destroy(enumerator);
 			return FALSE;
@@ -725,6 +725,7 @@
 	auth_cfg_t *auth;
 	signature_params_t *scheme;
 	int pathlen;
+	bool is_anchor = FALSE;
 
 	auth = auth_cfg_create();
 	get_key_strength(subject, auth);
@@ -742,7 +743,7 @@
 				auth->add(auth, AUTH_RULE_CA_CERT, issuer->get_ref(issuer));
 				DBG1(DBG_CFG, "  using trusted ca certificate \"%Y\"",
 							  issuer->get_subject(issuer));
-				trusted = TRUE;
+				trusted = is_anchor = TRUE;
 			}
 			else
 			{
@@ -777,11 +778,18 @@
 				DBG1(DBG_CFG, "  issuer is \"%Y\"",
 					 current->get_issuer(current));
 				call_hook(this, CRED_HOOK_NO_ISSUER, current);
+				if (trusted)
+				{
+					DBG1(DBG_CFG, "  reached end of incomplete trust chain for "
+						 "trusted certificate \"%Y\"",
+						 subject->get_subject(subject));
+				}
 				break;
 			}
 		}
-		if (!check_certificate(this, current, issuer, online,
-							   pathlen, trusted, auth))
+		/* don't do online verification here */
+		if (!check_certificate(this, current, issuer, FALSE,
+							   pathlen, is_anchor, auth))
 		{
 			trusted = FALSE;
 			issuer->destroy(issuer);
@@ -793,7 +801,7 @@
 		}
 		current->destroy(current);
 		current = issuer;
-		if (trusted)
+		if (is_anchor)
 		{
 			DBG1(DBG_CFG, "  reached self-signed root ca with a "
 				 "path length of %d", pathlen);
@@ -806,6 +814,34 @@
 		DBG1(DBG_CFG, "maximum path length of %d exceeded", MAX_TRUST_PATH_LEN);
 		call_hook(this, CRED_HOOK_EXCEEDED_PATH_LEN, subject);
 	}
+	else if (trusted && online)
+	{
+		enumerator_t *enumerator;
+		auth_rule_t rule;
+
+		/* do online revocation checks after basic validation of the chain */
+		pathlen = 0;
+		current = subject;
+		enumerator = auth->create_enumerator(auth);
+		while (enumerator->enumerate(enumerator, &rule, &issuer))
+		{
+			if (rule == AUTH_RULE_CA_CERT || rule == AUTH_RULE_IM_CERT)
+			{
+				if (!check_certificate(this, current, issuer, TRUE, pathlen++,
+									   rule == AUTH_RULE_CA_CERT, auth))
+				{
+					trusted = FALSE;
+					break;
+				}
+				else if (rule == AUTH_RULE_CA_CERT)
+				{
+					break;
+				}
+				current = issuer;
+			}
+		}
+		enumerator->destroy(enumerator);
+	}	
 	if (trusted)
 	{
 		result->merge(result, auth, FALSE);
